#ifndef PERSPECTIVECAMERA_HXX
#define PERSPECTIVECAMERA_HXX

#include "Camera.hxx"

class PerspectiveCamera : public Camera
{
public:
  PerspectiveCamera(const Vec3f& pos,
		    const Vec3f& dir,
		    const Vec3f& up,
		    float angle,
		    int resX, 
		    int resY
		    );
  ~PerspectiveCamera();

  virtual bool InitRay(float x, float y, Ray &ray);

private:
  //! hidden constructors to prevent misuse. If you need those at some point, just make them public and implement them properly!
  PerspectiveCamera();
  PerspectiveCamera(const PerspectiveCamera& c);
  PerspectiveCamera& operator=(const PerspectiveCamera& c);

  //! input values
  Vec3f m_pos, m_dir, m_up;
  float m_angle;
  
  //! preprocessed values
  float m_focus;
  Vec3f m_xAxis, m_yAxis, m_zAxis;
  float m_aspect;
};
#endif
